#!/bin/bash

# 安装Nvidia 闭源驱动
function installNvidiaDriver() {
	echo "mount kernel filesystem"
	mount -t proc proc /proc
	mount -t sysfs sysfs /sys
	mount -t devpts devpts /dev/pts
	mount -t tmpfs tmpfs /dev/shm
	echo "install nvidia driver"
	dpkg -P cdos-gfx-drv-switch xserver-xorg-video-s3g
	#dpkg -P ocl-icd-libopencl1  # conflict
	#apt-get -y --install-recommends --install-suggests install xserver-xorg-video-nvidia
	apt-get -y --install-recommends --install-suggests install nvidia-driver-libs:amd64 nvidia-driver-libs:i386 xserver-xorg-video-nvidia

	echo "reconfigure all packages...."
	dpkg --configure -a
	dpkg --configure -a
        ln -s /usr/lib/x86_64-linux-gnu/libGL.so.1 /usr/lib/libGL.so
        echo FRAMEBUFFER=y | tee /etc/initramfs-tools/conf.d/splash
        echo "GRUB_GFXMODE=1024x768" >> /etc/default/grub
        echo "GRUB_GFXPAYLOAD_LINUX=keep" >>/etc/default/grub
        update-grub2
        update-initramfs -u
	echo "Umount kernel filesystem"
	umount /proc
	umount /sys
	umount /dev/pts
	umount /dev/shm
}

have_nvidia=`lspci -nn | grep VGA |grep -i NVIDIA | tr 'a-z' 'A-Z' `

if [ -z "$have_nvidia" ]; then
	echo "not nvidia, return"
	exit 0
fi

echo "it is nvidia" 

cat /usr/share/nfsdrivers/nvidia_device_ids | while read line
do 
	if [[ $have_nvidia == *"$line"* ]]; then
		echo "match id"
		installNvidiaDriver
		break
	fi
done

